#include <vcl.h>
#include <stdio.h>
#include <TCHAR.H>
#pragma hdrstop

#include "Excom0.h"
//---------------------------------------------------------------------------
#pragma link "AdPort"
#pragma link "OoMisc"
#pragma link "AdWnPort"
#pragma link "AdPacket"
#pragma resource "*.dfm"
TForm1 *Form1;
String Stroka="";

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
out = NULL;
start = TDateTime(0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SendClick(TObject *Sender)
{
int LEN = Edit1->Text.ToInt();
char s = 0;
BYTE *buf = new BYTE[LEN];
for(int i = 0; i < LEN; i++)
     buf[i] = s++;
TDateTime start, finish;
start = Now();
for(int i = 0; i < 10; i++)
     {
      ApdComPort1->PutBlock(buf, LEN);
      while (ApdComPort1->OutBuffUsed != 0) ;
     }
finish = Now();
Label1->Caption = TimeToStr(start) + "\r\n" + TimeToStr(finish);
delete [] buf;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ApdComPort1TriggerAvail(TObject *CP, WORD Count)
{
if (start == TDateTime(0)) {
                           start = Now();
                           Label1->Caption = TimeToStr(start);
                          }
  size += Count;
  sos->Caption = "GetMsg - " + IntToStr(Tag++) + " (" + IntToStr(size) + ")";
/*  try {*/
       ApdComPort1->GetBlock(&BUF[0], Count);
/*      }
  catch(Exception &E) { ShowMessage(E.Message); }*/
  if (out == NULL)
     out = new TMemoryStream();
  out->WriteBuffer(&BUF[0], Count);                            
end = Now();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClearClick(TObject *Sender)
{
  Memo1->Text="";
  Tag = 0;
  size = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ReadClick(TObject *Sender)
{
Tag = 0;
Label1->Caption = Label1->Caption + "\r\n" + TimeToStr(end);
start = TDateTime(0);
end = TDateTime(0); 
size = 0;
out->SaveToFile("data.txt");
delete out;
out = NULL;
Memo1->Text = Stroka;
sos->Font->Color = clNavy;
sos->Caption = " ";
//Edit2->Text = Stroka;
Stroka = "";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LinkClick(TObject *Sender)
{
ApdComPort1->ComNumber = Portnum->ItemIndex + 1;
SpeedChange(Speed);
ApdComPort1->Open = true;                               
sos->Font->Color = clNavy;
 sos->Caption = " ";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UnlinkClick(TObject *Sender)
{
ApdComPort1->Open = false;                       
sos->Font->Color = clNavy;
 sos->Caption = " ";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ExitClick(TObject *Sender)
{
ApdComPort1->Open = false;
Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{

 Memo1->Text = "";                                 
 sos->Font->Color = clNavy;
 sos->Caption = " ";
 Speed->ItemIndex = 6;
 Portnum->ItemIndex = 0;
}
//---------------------------------------------------------------------------
        

void __fastcall TForm1::SpeedChange(TObject *Sender)
{
if (Speed->ItemIndex== 0) ApdComPort1->Baud = 2400;
if (Speed->ItemIndex== 1) ApdComPort1->Baud = 4800;
if (Speed->ItemIndex== 2) ApdComPort1->Baud = 9600;
if (Speed->ItemIndex== 3) ApdComPort1->Baud = 19200;
if (Speed->ItemIndex== 4) ApdComPort1->Baud = 38400;
if (Speed->ItemIndex== 5) ApdComPort1->Baud = 57600;
if (Speed->ItemIndex== 6) ApdComPort1->Baud = 115200;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PortChange(TObject *Sender)
{
 if (Portnum->ItemIndex== 0) ApdComPort1->ComNumber = 1;
 if (Portnum->ItemIndex== 1) ApdComPort1->ComNumber = 2;
 if (Portnum->ItemIndex== 2) ApdComPort1->ComNumber = 3;
 if (Portnum->ItemIndex== 3) ApdComPort1->ComNumber = 4;
}
//---------------------------------------------------------------------------






void __fastcall TForm1::ApdProtocol1ProtocolFinish(TObject *CP,
      int ErrorCode)
{
ShowMessage("Protocol finished: " + ErrorMsg(ErrorCode));
//  ApdTerminal1->Active = true;

}
//---------------------------------------------------------------------------




void __fastcall TForm1::ApdProtocol1ProtocolAccept(TObject *CP,
      bool &Accept, TPassString &FName)
{
sos->Caption="   "+FName;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ApdProtocol1ProtocolError(TObject *CP,
      int ErrorCode)
{
sos->Caption="Error "+IntToStr(ErrorCode);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormActivate(TObject *Sender)
{
OnActivate = NULL;
Link->Click();
Read->SetFocus();
}
//---------------------------------------------------------------------------
void EnumerateSerialPorts()
{
//    ?
String txt;
OSVERSIONINFO osvi;
osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
BOOL bGetVer = GetVersionEx(&osvi);
//  NT  API QueryDosDevice
if(bGetVer && (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT))
  {
    //  QueryDosDevice       COMx.
   //   ,      
    TCHAR szDevices[65535];
    DWORD dwChars = QueryDosDevice(NULL, szDevices, 65535);
    if(dwChars)
      {
        int i=0;
          for (;;)
            {
              //    
              TCHAR* pszCurrentDevice = &szDevices[i];
              //    "COMX"   
              int nLen = _tcslen(pszCurrentDevice);
                if(nLen > 3 && _tcsnicmp(pszCurrentDevice, _T("COM"), 3) == 0)
                   txt = txt + StrPas(pszCurrentDevice) + "\r\n";
              //     
              while(szDevices[i] != _T('\0')) i++;
              //    
                i++;
              //     ,    
              // NULL,    
              if(szDevices[i] == _T('\0')) break;
            } // for (;;)
        } // if(dwChars)
  } // if(bGetVer && (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT))
else
  {
    //  95/98       
    //   255 COM ,       
    //      ,     ,
    //  access denied        
    // ,      .
    for (UINT i=1; i<256; i++)
      {
        //    
        char sPort[10];
        sprintf(sPort,"\\\\.\\COM%d", i);
        //    
        bool bSuccess = false;
        HANDLE hPort = CreateFile(sPort, GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0);
        if(hPort == INVALID_HANDLE_VALUE)
          {
            DWORD dwError = GetLastError();
            //     
            if(dwError == ERROR_ACCESS_DENIED || dwError == ERROR_GEN_FAILURE)
               bSuccess = true;
              }
        else  {
                //   
                bSuccess = true;
                //      ,
                //        ...
                CloseHandle(hPort);
              } // if(hPort == INVALID_HANDLE_VALUE)
            //     
            if(bSuccess == true)
               {
                String s = StrPas(sPort);
                s.Delete(1, 3);
                txt = txt + s + "\r\n";
               }
          } // for (UINT i=1; i<256; i++)
      } // if(bGetVer && (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT))
ShowMessage(txt);

TCHAR szDevices[65535];
DWORD dwChars = QueryDosDevice(NULL, szDevices, 65535);
TFileStream *f = new TFileStream("1.txt", fmCreate);
f->WriteBuffer(szDevices, dwChars);
delete f;
}
//------------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
EnumerateSerialPorts();
}
//---------------------------------------------------------------------------

