/*********************************************************/
/*                      EXCOM0.H                         */
/*   Copyright (c) TurboPower Software Co., 1997, 1998   */
/*                 All Rights Reserved                   */
/*********************************************************/
//---------------------------------------------------------------------------
#ifndef Excom0H
#define Excom0H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "AdPort.hpp"
#include "OoMisc.hpp"
#include "AdWnPort.hpp"
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TApdComPort *ApdComPort1;
        TButton *Send;
        TButton *Clear;
        TButton *Read;
        TButton *Link;
        TButton *Unlink;
        TButton *Exit;
        TMemo *Memo1;
        TGroupBox *GroupBox1;
        TGroupBox *GroupBox2;
        TLabel *sos;
        TGroupBox *GroupBox3;
        TComboBox *Speed;
        TComboBox *Portnum;
     TLabel *Label1;
     TEdit *Edit1;
     TButton *Button1;
	void __fastcall SendClick(TObject *Sender);
	void __fastcall ApdComPort1TriggerAvail(TObject *CP, WORD Count);
        void __fastcall ClearClick(TObject *Sender);
        void __fastcall ReadClick(TObject *Sender);
        void __fastcall LinkClick(TObject *Sender);
        void __fastcall UnlinkClick(TObject *Sender);
        void __fastcall ExitClick(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall SpeedChange(TObject *Sender);
        void __fastcall PortChange(TObject *Sender);
        void __fastcall ApdProtocol1ProtocolFinish(TObject *CP,
          int ErrorCode);
    void __fastcall ApdProtocol1ProtocolAccept(TObject *CP, bool &Accept,
          TPassString &FName);
    void __fastcall ApdProtocol1ProtocolError(TObject *CP, int ErrorCode);
     void __fastcall FormActivate(TObject *Sender);
     void __fastcall Button1Click(TObject *Sender);
private:	// User declarations
     char C;
     TMemoryStream *out;
public:		// User declarations
char *FileToSend;
 BYTE BUF[4096];
 int size;
 TDateTime start, end;
	virtual __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
